<template>
  <div class="ob-form-container">
    <div class="form-body">
      <ob-tabs>
        <ob-tabs-pane title="Контрагент" :is-selected="true">
          <ob-select
            ref="select"
            @bottom="openModal"
            v-model="formData.cargoContractorTitle"
            :items="form.contractor.items"
            :label="form.contractor.label"
            :is-dropdown="form.contractor.isDropdown"
            :is-standart="true"
            :value-exp="form.contractor.valueExp"
            :page-limit="form.contractor.pageLimit"
            :placeholder="form.contractor.placeholder"
            :itemBottom="{
              icon: 'plus',
              title: `Добавить г${contractorTypeWordRoot}я`,
            }"
            :invalid="!form.contractor.valid"
            class="mt30 mb20"
            data-qa="contractorSelect"
            @input="validate"
          >
            <template v-slot="{ items }">
              <div v-if="items">
                <div
                  class="contractor"
                  v-for="(item, index) in items.filter(
                    (i) => i.location === 'near'
                  )"
                  :key="item.uuid"
                  :data-qa="'contractorSelect_' + index"
                >
                  <p
                    v-if="
                      index === 0 &&
                        items.filter((i) => i.location === 'other').length
                    "
                  >
                    Неподалёку от г. {{ address.label }}
                  </p>
                  <div class="contractor__item" @click="selectContractor(item)">
                    {{ item.title }}
                    <span v-if="item.inn">{{ item.inn }}</span>
                  </div>
                </div>

                <div
                  class="contractor"
                  v-for="(item, index) in items.filter(
                    (i) => i.location === 'other'
                  )"
                  :key="item.uuid"
                  :data-qa="'contractorSelect_' + index"
                >
                  <p
                    v-if="
                      index === 0 &&
                        items.filter((i) => i.location === 'near').length
                    "
                  >
                    Другие грузоотправители
                  </p>
                  <div class="contractor__item" @click="selectContractor(item)">
                    {{ item.title }}
                    <span v-if="item.inn">{{ item.inn }}</span>
                  </div>
                </div>
              </div>
            </template>
          </ob-select>
          <div class="contractorInn" v-if="currentInn">
            <span>ИНН</span>
            {{ currentInn }}
          </div>
          <ObAddressInput
            :title="form.address.label"
            :address="formData.pointAddress"
            :mapAddress="mapAddress"
            :isValid="form.address.valid"
            :popoverMessage="this.form.address.errorTooltip"
            :showMap="false"
            customIcon="map"
            customAction
            prefixIcon="pin"
            :locationsTypes="locationsTypes"
            :isAddressOnly="true"
            :placeholder="form.address.placeholder"
            mapId="add-modal-map"
            :disabled="isAddressInputDisabled"
            display-exp="russian_address"
            class="mb20"
            data-qa="pointAddress"
            @input="setPointAddress"
            @on-change-address="setPointAddress"
            @customAction="onOpenMapModal(mapAddress)"
          />
          <ob-input
            :placeholder="form.addressDoc.placeholder"
            :label="form.addressDoc.label"
            :isValid="form.addressDoc.valid"
            :validationMessage="
              form.addressDoc.valid ? '' : form.addressDoc.errorTooltip
            "
            :isDirtyForce="true"
            v-model="formData.tsdAddress"
            class="mb20"
            @input="validate"
          />
          <ob-input
            :placeholder="form.code.placeholder"
            :label="form.code.label"
            v-model="formData.pointCode"
            class="mb20"
            @input="validate"
          />
          <div class="form-group mb20">
            <ob-datepicker
              v-model="formData.timeSlotStartAt"
              label="Дата и время начала слота"
              :sinceTo="disabledStartDates"
              :blockTimeDateBefore="new Date(pvpDate)"
              :isValidDate="form.timeSlotStart.valid"
              :dateValidationMessage="form.timeSlotStart.errorTooltip"
              key="from"
              is-time
              :timeInterval="15"
              class="w-half"
              position="top-start"
              @input="validate"
            />
            <ob-datepicker
              v-model="formData.timeSlotEndAt"
              label="Дата и время окончания слота"
              :sinceTo="disabledEndDates"
              :blockTimeDateBefore="new Date(pvpDate)"
              :isValidDate="form.timeSlotEnd.valid"
              :dateValidationMessage="form.timeSlotEnd.errorTooltip"
              key="until"
              is-time
              :timeInterval="15"
              class="w-half"
              position="top-start"
              @input="validate"
            />
          </div>
          <ob-textarea
            :placeholder="form.extraInfo.placeholder"
            :label="form.extraInfo.label"
            v-model="formData.comments"
            @input="validate"
          />

          <ob-modal
            ref="add-consignor-modal"
            size="small"
            :title="`Новый г${contractorTypeWordRoot}ь`"
            is-center
            is-nested
            data-qa="addContractorModal"
            @opened="focusModal"
          >
            <ob-form
              @submit="createContractor"
              :formData="formDataContractor"
              okText="Добавить"
              data-qa="addContractorForm"
            >
              <div class="form-row">
                <ob-input
                  ref="title"
                  :placeholder="
                    `Наименование нового г${contractorTypeWordRoot}я`
                  "
                  :label="`Г${contractorTypeWordRoot}ь`"
                  v-model="formDataContractor.contractor"
                  :isValid="isContractorValid"
                  data-qa="contractorName"
                  @input="clearContractorsError"
                />
                <error-message
                  v-if="isContractorValid === false"
                  :message="contractorError"
                />
              </div>

              <div class="form-row">
                <ob-input
                  placeholder="Укажите ИНН"
                  label="ИНН"
                  v-model="formDataContractor.inn"
                  data-qa="contractorInn"
                />
              </div>
            </ob-form>
          </ob-modal>
        </ob-tabs-pane>

        <ob-tabs-pane title="Инфозапись" is-disabled />
        <ob-tabs-pane title="Груз к отправке" is-disabled />
      </ob-tabs>
    </div>
    <div class="form-footer">
      <div class="ob-form-controls-container">
        <div class="form-controls__left">
          <ob-button
            @click="handleSubmit"
            label="Сохранить"
            :disabled="disabledSubmit"
          >
            <div class="button-loader" v-if="isSaving">
              <svg version="1.1" id="L9" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"
                viewBox="0 0 100 100" enable-background="new 0 0 0 0" xml:space="preserve">
                  <path fill="currentColor" d="M73,50c0-12.7-10.3-23-23-23S27,37.3,27,50 M30.9,50c0-10.5,8.5-19.1,19.1-19.1S69.1,39.5,69.1,50">
                    <animateTransform 
                      attributeName="transform" 
                      attributeType="XML" 
                      type="rotate"
                      dur="1s" 
                      from="0 50 50"
                      to="360 50 50" 
                      repeatCount="indefinite" />
                </path>
              </svg>
            </div>
          </ob-button>
          <ob-button type="flat" :disabled="isSaving" @click="handleCancel" label="Отмена" />
        </div>
      </div>
    </div>
    <AddressMapModal
      ref="mapModal"
      :data-source="{ address: {} }"
      :value="this.activeAddress"
      :locationsTypes="locationsTypes"
      isVisitPoint
      :isRadius="false"
      mapId="add-modal-map"
      dataQa="addContractorAddress"
      @input="setAddressFromModal"
      @error="onAddressMapError"
    />
  </div>
</template>

<script>
import { uuid } from "vue-uuid";
// import moment        from 'moment';
// import { tokenData } from "@/tokenData";
import api from "@/api";
import models from "@/models";

import ObAddressInput from "common-components/src/obComponents/obAddressInput";
import ObDatepicker from "common-components/src/obComponents/obDatePickerConstructor";
import ObForm from "common-components/src/obComponents/obForm";
import ObInput from "common-components/src/obComponents/obInput";
import ObModal from "common-components/src/obComponents/obModal";
import ObSelect from "common-components/src/obComponents/obSelect";
import ObTabs from "common-components/src/obComponents/obTabs";
import ObTabsPane from "common-components/src/obComponents/obTabs/ObTabsPane";
import ObTextarea from "common-components/src/obComponents/obTextarea";
import ObButton from "common-components/src/obComponents/obButton";
import AddressMapModal from "../../../pages/logchainPage/components/logchainMapModal";
import ErrorMessage from "@/components/ErrorMessage";

const t = {
  consignor: "FROM",
  consignee: "TO",
};

export default {
  name: "visit-point-modal",
  components: {
    ObAddressInput,
    ObDatepicker,
    ObForm,
    ObInput,
    ObModal,
    ObSelect,
    ObTabs,
    ObTabsPane,
    ObTextarea,
    ObButton,
    AddressMapModal,
    ErrorMessage,
  },
  props: {
    pvpDate: {
      type: String,
      required: true
    },
    locationsTypes: {
      type: Array,
      required: true,
    },
    visitPointUuid: {
      type: String,
      required: true,
    },
    address: {
      type: Object,
      required: true,
    },
    contractorUuid: {
      type: String,
      required: true,
    },
    brif: {
      type: Object,
      required: true,
    },
  },
  errosMap: {
    CARGOCONTRACTORTITLE: "contractor",
    POINTADDRESS: "address",
    TIMESLOTSTARTAT: "timeSlotStart",
    TIMESLOTENDAT: "timeSlotEnd",
  },
  data() {
    return {
      isSaving: false,
      activeContractorUuid: '',
      isContractorValid: null,
      contractorError: "",
      activeAddress: {},
      hasErrors: false,
      originalData: "",
      dirty: false,
      form: {
        contractor: {
          items: [],
          isDropdown: false,
          valueExp: "title",
          label: "Грузоотправитель",
          pageLimit: 20,
          placeholder: "Выберите из списка",
          valid: true,
          errorTooltip: "",
        },
        address: {
          label: "Фактический адрес прибытия",
          coordinates: { lat: null, lon: null },
          placeholder: "Укажите адрес",
          valid: true,
          errorTooltip: "",
        },
        timeSlotStart: {
          valid: true,
          errorTooltip: "",
        },
        timeSlotEnd: {
          valid: true,
          errorTooltip: "",
        },
        addressDoc: {
          label: "Адрес для печатной формы заявки",
          placeholder: "Укажите адрес",
          valid: null,
          errorTooltip: "asassa",
        },
        code: {
          label: "Код объекта",
          placeholder: "Укажите код",
        },
        label: {
          label: "Hазвание",
          placeholder: "Введите название",
        },
        extraInfo: {
          label: "Дополнительная и контактная информация",
          placeholder: "Введите комментарий",
        },
        tabs: [
          { code: 1, title: "Контрагент" },
          { code: 2, title: "Инфозапись" },
          { code: 3, title: "Груз к отправке" },
        ],
      },
      formData: {
        baseLocationUuid: "",
        cargoContractorTitle: "",
        cargoContractorType: "",
        // clientUuid          : tokenData.user_uuid,
        clientUuid: this.contractorUuid,
        orderUuid: this.$route.params.id,
        pointAddress: "",
        pointCoordinate: {
          lat: "",
          lon: "",
        },
        pointCode: "",
        timeSlotEndAt: this.visitPoint?.timeSlotEndAt,
        timeSlotStartAt: this.visitPoint?.timeSlotStartAt,
        tsdAddress: "",
        visitPointUuid: "",
        comments: "",
      },
      formDataContractor: {
        contractor: "",
        inn: "",
        isConsignee: false,
        isConsignor: false,
        // ownerUuid  : tokenData.user_uuid,
        ownerUuid: this.contractorUuid,
      },
      // uuid: tokenData.user_uuid,
      uuid: this.contractorUuid,
      visitPoint: null,
      isLoading: true,
    };
  },

  computed: {
    disabledSubmit() {
      const filledForm = !!(
        this.formData.cargoContractorTitle?.length &&
        this.formData.pointAddress?.length &&
        this.formData.tsdAddress?.length &&
        this.formData.timeSlotStartAt &&
        this.formData.timeSlotEndAt
      );

      return !filledForm || this.hasErrors || !this.dirty || this.isSaving;
    },
    firstPointDt() {
      let dt = null;
      if (this.brif && this.brif.visitPoints && this.brif.visitPoints.find) {
        const point = this.brif.visitPoints.find(point => point.type === 'FROM');
        if (point && point.timeSlot) {
          dt = point.timeSlot.date;
        }
      }
      return dt;
    },
    disabledStartDates() {
      return [
        {
          from: new Date(1976, 0, 0),
          to: new Date(this.firstPointDt).setHours(0, 0, 0),
        },
      ];
    },
    disabledEndDates() {
      return [
        {
          from: new Date(1976, 0, 0),
          to: this.computedTimeStartAt || new Date(this.firstPointDt).setHours(0, 0, 0),
        },
      ];
    },
    formModel: () => models.consignor.add,
    contractorTypeWordRoot() {
      return this.CONSIGNOR
        ? "рузоотправител" // ✌.ʕʘ‿ʘʔ.✌
        : "рузополучател";
    },
    contractorType() {
      if (!this.visitPoint) return;

      return this.visitPoint.consigneeOrConsignor;
    },
    isAddressInputDisabled() {
      if (!this.visitPoint) return;

      return this.visitPoint.type !== "REFERENCE_POSITION";
    },
    CONSIGNOR() {
      return this.contractorType === t.consignor;
    },

    CONSIGNEE() {
      if (!this.visitPoint) return;

      return this.contractorType === t.consignee;
    },

    mapAddress() {
      return {
        coordinates: {
          lat:
            (this.formData.pointCoordinate &&
              this.formData.pointCoordinate.lat) ||
            "",
          lon:
            (this.formData.pointCoordinate &&
              this.formData.pointCoordinate.lon) ||
            "",
        },
        label: this.formData.pointAddress || this.address.russianName,
      };
    },

    currentInn() {
      if (this.formData.cargoContractorTitle) {
        const contractor = this.form.contractor.items.find(
          (item) => item.title === this.formData.cargoContractorTitle
        );
        return contractor.inn || null;
      }

      return null;
    },
  },
  watch: {
    formData: {
      handler(newVal) {
        const val = JSON.stringify(newVal);
        this.dirty = val !== this.originalData;
      },
      deep: true,
    },
  },
  methods: {
    focusModal() {
      this.$nextTick(() => {
        this.$refs.title.focus();
      });
    },

    clearContractorsError() {
      this.isContractorValid = null;
      this.contractorError = "";
    },

    onOpenMapModal(point) {
      this.activeAddress = point;
      this.$refs.mapModal.open();
    },
    selectContractor(item) {
      this.$refs.select.setItem(item);
      this.activeContractorUuid = item.uuid;
    },
    async init() {
      this.isLoading = true;
      await this.processVisitPoint({ uuid: this.visitPointUuid });
      this.isLoading = false;
      this.validate();
    },
    async handleSubmit() {
      this.isSaving = true;
      try {
        await api.orders.updateVisitPoint(this.formData);
      } catch (error) {
        this.$notification({
          type: "system_notification_error",
          message: `Ошибка при обновлении точки погрузки`,
        });
        console.error(error);
      } finally {
        this.$emit("close");
        this.isSaving = false;
      }

      this.$emit("visit-point-updated");
    },
    handleCancel() {
      this.setFormData(this.visitPoint);
      this.hasErrors = false;
      this.form.contractor.valid = true;
      this.form.contractor.errorTooltip = "";
      this.form.address.valid = true;
      this.form.address.errorTooltip = "";
      this.form.addressDoc.errorTooltip = "";
      this.form.timeSlotStart.valid = true;
      this.form.timeSlotStart.errorTooltip = "";
      this.form.timeSlotEnd.valid = true;
      this.form.timeSlotEnd.errorTooltip = "";
      this.$emit("close");
    },
    async createContractor() {
      const addContractorToCurrentList = (title, uuid, inn) => {
        const isDuplicatedContractor = this.form.contractor.items.some(item => item.title === title);
        if (isDuplicatedContractor) {
          const contractor = this.form.contractor.items.find(item => item.title === title);
          contractor.inn = inn;
          this.dirty = true;      
        } else {
          this.form.contractor.items.push({ title, uuid, inn, location: 'other' });
        }
        this.formData.cargoContractorTitle = title;
        this.activeContractorUuid = uuid;
        this.formDataContractor.contractor = "";
        this.formDataContractor.inn = "";
        this.$refs["add-consignor-modal"].close();
      };
      const resetContractorFormData = () => {
        const newFormData = {
          contractor: "",
          isConsignee: false,
          isConsignor: false,
          ownerUuid: this.contractorUuid,
        };
        this.formDataContractor = {
          ...this.formDataContractor,
          ...newFormData,
        };
      };

      try {
        const newContractorUuid = uuid.v4();

        let contractorTypeKey = "isConsignee";
        if (this.CONSIGNOR) contractorTypeKey = "isConsignor";

        this.formDataContractor[contractorTypeKey] = true;

        await api.contractors.createContractor(
          newContractorUuid,
          this.formDataContractor
        );
        addContractorToCurrentList(
          this.formDataContractor.contractor,
          newContractorUuid,
          this.formDataContractor.inn
        );
        resetContractorFormData();
      } catch (e) {
        this.isContractorValid = false;
        this.contractorError = e.message;
      }
    },
    openModal() {
      this.$refs["add-consignor-modal"].open();
    },
    async generateContractorsList({ type, uuid, coordinates }) {
      this.form.contractor.items = [];
      let list = [];
      const payloadForDistance = { uuid, coordinates, type };
      const payloadForType = { ownerUuid: uuid, type };

      try {
        try {
          const {
            data: { list: excludedList },
          } = await api.contractors.getContractorsByDistance(
            payloadForDistance
          );
          const formatedExcludedList = excludedList.map((item) => item.uuid);
          payloadForType.list = formatedExcludedList;

          list = list.concat(
            excludedList.map((item) => ({ ...item, location: "near" }))
          );
        } catch (error) {
          console.error("fetch_contractors error", error);
          this.$notification({
            type: "system_notification_error",
            message: "Ошибка загрузки данных",
          });
        }

        const {
          data: { list: othersList },
        } = await api.contractors.getContractorsByType(payloadForType);
        list = list.concat(
          othersList.map((item) => ({ ...item, location: "other" }))
        );
      } catch (error) {
        console.error("fetch_list_exclude error", error);
      }

      this.form.contractor.items = this.form.contractor.items.concat(list);
    },
    async tryAddTypeToContractor({ type, contractorUuid }) {
      try {
        await api.contractors.addTypeToContractor({
          contractorUuid,
          ownerUuid: this.contractorUuid,
          type,
        });
      } catch (e) {
        console.error("tryAddToContractor");
        this.$notification({
          type: "system_notification_error",
          message: "Ошибка при добавлении нового исполнителя",
        });
      }
    },
    validate() {
      this.hasErrors = false;
      this.form.contractor.valid = true;
      this.form.contractor.errorTooltip = "";
      this.form.address.valid = true;
      this.form.address.errorTooltip = "";
      this.form.addressDoc.valid = null;
      this.form.addressDoc.errorTooltip = "";
      this.form.timeSlotStart.valid = true;
      this.form.timeSlotStart.errorTooltip = "";
      this.form.timeSlotEnd.valid = true;
      this.form.timeSlotEnd.errorTooltip = "";
      api.orders
        .validatePoints(this.formData)
        .then((res) => {
          if (res.length) {
            const isError = res
              .reduce((acc, item) => {
                acc.push(item.response.responseType);
                return acc;
              }, [])
              .includes("ERROR");
            const isWarning = res.some(
              (item) => item.response.responseType === "WARNING"
            );
            this.hasErrors = isError ? true : false;
            if (isError || isWarning) {
              res.forEach((item) => {
                if (item.response.code === "TIMESLOT") {
                  this.form.timeSlotStart.valid = false;
                  this.form.timeSlotStart.errorTooltip =
                    item.response.description;
                  this.form.timeSlotEnd.valid = false;
                  this.form.timeSlotEnd.errorTooltip =
                    item.response.description;
                } else {
                  this.form[
                    this.$options.errosMap[item.response.code]
                  ].valid = false;
                  this.form[
                    this.$options.errosMap[item.response.code]
                  ].errorTooltip = item.response.description;
                }
              });
            }
          } else {
            // this.hasErrors = false;
            // for (let i of this.form) {
            //   i.valid = true;
            //   i.errorTooltip = '';
            // }
          }
        })
        .catch((err) => {
          console.error(err);
        });
    },
    setPointAddress($event) {
      const pointAddress = $event;
      this.formData.pointAddress = pointAddress.label;
      this.formData.tsdAddress = pointAddress.label;
      this.formData.pointCoordinate = pointAddress.coordinates;
      this.validate();
    },
    setAddressFromModal(e) {
      const addr = {
        coordinates: {
          lat: e.payload.coordinates.lat,
          lon: e.payload.coordinates.long,
        },
        isValid: true,
        icon: e.payload.icon,
        label: e.payload.label,
        locationUuid: e.payload.uuid || "",
      };
      this.setPointAddress(addr);
    },
    onAddressMapError() {
      this.$refs.mapModal.close();
      this.$notification({
        type: "system_notification_error",
        message: "Ошибка загрузки карты",
      });
    },
    setFormData(visitPoint = {}) {
      const isConsignor = visitPoint.consigneeOrConsignor === "FROM";

      this.form.contractor.label = isConsignor
        ? "Грузоотправитель"
        : "Грузополучатель";
      this.formData.pointAddress = visitPoint.address;
      this.formData.comments = visitPoint.comments;
      this.formData.baseLocationUuid = visitPoint.locationUuid;
      this.formData.cargoContractorTitle = visitPoint.title;
      this.formData.cargoContractorType = isConsignor
        ? "CONSIGNOR"
        : "CONSIGNEE";
      // this.formData.clientUuid           = tokenData.user_uuid
      (this.formData.clientUuid = this.contractorUuid),
        (this.formData.orderUuid = this.$route.params.id);
      this.formData.pointAddress = visitPoint.address;
      this.formData.pointCoordinate = visitPoint.coordinates;
      this.formData.pointCode = visitPoint.code;
      this.formData.timeSlotEndAt = visitPoint.timeSlotEndAt;
      this.formData.timeSlotStartAt = visitPoint.timeSlotStartAt;
      this.formData.tsdAddress = visitPoint.tsdAddress
        ? visitPoint.tsdAddress
        : visitPoint.address;
      this.formData.visitPointUuid = this.visitPointUuid;

      if (visitPoint.type === "ADDRESS" && !visitPoint.address) {
        this.formData.pointAddress = this.address.label;
        this.formData.pointCoordinate = this.address.coordinates;
        this.formData.baseLocationUuid = this.address.locationUuid;
      }

      this.originalData = JSON.stringify(this.formData);
    },
    async processVisitPoint({ uuid }) {
      this.setFormData({});
      try {
        const { data } = await api.orders.getVisitPoint({ uuid });
        this.visitPoint = data;
      } catch (e) {
        console.error(e);
        this.$notification({
          type: "system_notification_error",
          message: "Ошибка чтения данных",
        });
        this.$emit("close");
      }

      try {
        await this.generateContractorsList({
          type: this.CONSIGNOR ? "CONSIGNOR" : "CONSIGNEE",
          uuid: this.uuid,
          coordinates: this.visitPoint.coordinates || this.coordinates,
        });
      } catch (e) {
        this.$notification({
          type: "system_notification_error",
          message: "Ошибка при генерации списка исполнителей",
        });
        console.error(e);
      }

      this.setFormData(this.visitPoint);
    },
  },
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.mb20 {
  margin-bottom: 20px;
}
.mt30 {
  margin-top: 30px;
}
.w-half {
  width: calc(50% - 5px);
}
.form-group {
  display: flex;
  justify-content: space-between;
}
.contractor {
  @include font-mixin(15px, 16px, 400, $color-text-base);

  p {
    padding: 12px 22px 5px 22px;
    @include font-mixin(12px, 16px, 400, $color-grey-label);
  }

  .contractor__item {
    display: flex;
    flex-direction: column;
    padding: 12px 22px;
    cursor: pointer;

    &:hover {
      background-color: $light-lavender;
    }

    span {
      padding-top: 3px;
      @include font-mixin(12px, 16px, 400, $color-grey-label);
    }
  }
}

.contractor + .contractor p {
  margin-top: 5px;
}

.contractorInn {
  margin-top: -10px;
  margin-bottom: 20px;
  @include font-mixin(14px, 18px, 400, $color-text-base);

  span {
    color: $gray-slate;
  }
}

.form-row + .form-row {
  margin-top: 20px;
}

.error-message {
  margin-top: 20px;
}

.button-loader svg {
  width: 40px;
  height: 40px;
}
</style>
